## -*-makefile-*-
##
## $Id: Makefile.m4,v 1.2 1999/07/06 19:36:05 mdw Exp $
##
## Makefile for mLib's manual pages
##
## (c) 1999 Straylight/Edgeware
##

##----- Licensing notice ----------------------------------------------------
##
## This file is part of the mLib utilities library.
##
## mLib is free software; you can redistribute it and/or modify
## it under the terms of the GNU Library General Public License as
## published by the Free Software Foundation; either version 2 of the
## License, or (at your option) any later version.
## 
## mLib is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Library General Public License for more details.
## 
## You should have received a copy of the GNU Library General Public
## License along with mLib; if not, write to the Free
## Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
## MA 02111-1307, USA.

##----- Revision history ----------------------------------------------------
##
## $Log: Makefile.m4,v $
## Revision 1.2  1999/07/06 19:36:05  mdw
## Various minor bugfixes.
##
## Revision 1.1  1999/07/06 19:14:22  mdw
## Makefile for manual page installation.  Subtle and complicated.
##

AUTOMAKE_OPTIONS = foreign no-installman

dnl --- Read in the various lists of things ---

define(`nl', `
')
define(`joinlines', `patsubst(patsubst(`$1', nl$, `'), nl, `$2')')
define(`filenonl', `\nl	$2`'joinlines(include(`$1'), ` \\'nl`	$2')')
define(`TOPLEVEL', filenonl(`toplevel'))
define(`LINKS', filenonl(`links'))
define(`SRC_TOPLEVEL', filenonl(`toplevel', `$(srcdir)/'))
define(`SRC_LINKS', filenonl(`links', `$(srcdir)/'))

## --- Manual pages ---

man_MANS = TOPLEVEL LINKS

EXTRA_DIST = Makefile.m4 $(man_MANS) mksofiles links toplevel stamp-so.in

## --- Various maintenance rules ---

MAINTAINERCLEANFILES = SRC_LINKS $(srcdir)/Makefile.am $(srcdir)/stamp-so.in

$(srcdir)/links $(srcdir)/toplevel: stamp-so.in

$(srcdir)/stamp-so.in: TOPLEVEL
	cd $(srcdir); ./mksofiles *.[1-9]
	touch $(srcdir)/stamp-so.in

$(srcdir)/Makefile.am: \
	$(srcdir)/Makefile.m4 $(srcdir)/links $(srcdir)/toplevel
	cd $(srcdir); m4 Makefile.m4 >Makefile.am

##----- That's all, folks ---------------------------------------------------
