/* -*-c-*-
 *
 * $Id: quis.c,v 1.5 1999/10/04 21:44:06 mdw Exp $
 *
 * Setting the program name
 *
 * (c) 1998 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------* 
 *
 * This file is part of the mLib utilities library.
 *
 * mLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * mLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with mLib; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

/*----- Revision history --------------------------------------------------*
 *
 * $Log: quis.c,v $
 * Revision 1.5  1999/10/04 21:44:06  mdw
 * Undefine PATHSEP when finished with.
 *
 * Revision 1.4  1999/05/06 19:51:35  mdw
 * Reformatted the LGPL notice a little bit.
 *
 * Revision 1.3  1999/05/05 18:50:31  mdw
 * Change licensing conditions to LGPL.
 *
 * Revision 1.2  1999/02/28 15:16:29  mdw
 * quis: remove the leading `-' from the name, in case we're invoked as a
 * login shell.
 *
 * Revision 1.1.1.1  1998/06/17 23:44:42  mdw
 * Initial version of mLib
 *
 */

/*----- Header files ------------------------------------------------------*/

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "quis.h"

/*----- Global variables --------------------------------------------------*/

const char *pn__name = "<UNNAMED>";	/* Program name */

/*----- Functions provided ------------------------------------------------*/

/* --- @quis@ --- *
 *
 * Arguments:	---
 *
 * Returns:	Pointer to the program name.
 *
 * Use:		Returns the program name.
 */

const char *quis(void) { return (QUIS); }

/* --- @ego@ --- *
 *
 * Arguments:	@const char *p@ = pointer to program name
 *
 * Returns:	---
 *
 * Use:		Tells mLib what the program's name is.
 */

#ifndef PATHSEP
#  if defined(__riscos)
#    define PATHSEP '.'
#  elif defined(__unix) || defined(unix)
#    define PATHSEP '/'
#  else
#    define PATHSEP '\\'
#  endif
#endif

void ego(const char *p)
{
  const char *q = p;
  while (*q) {
    if (*q++ == PATHSEP)
      p = q;
  }
  if (*p == '-')
    p++;
  pn__name = p;
}

#undef PATHSEP

/*----- That's all, folks -------------------------------------------------*/
